//---------   Kl_WG_Automat.cpp   ------------------------------------------
// Implementierung der Operationen der Klasse WechselgeldAutomat

#include "Kl_WG_Automat.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
WechselgeldAutomat::WechselgeldAutomat( TdieGUI1 *pGUI1, TdieGUI2 *pGUI2)
{
  Muenzen l_Muenzen;

  dieGUI1 = pGUI1;
  dieGUI2 = pGUI2;

  dasCtMagazin[0] = new GeldMagazin(10);        
  dasCtMagazin[1] = new GeldMagazin(20);
  dasCtMagazin[2] = new GeldMagazin(20);

  l_Muenzen = leseFuellstand();
  dieGUI2->merkeKapazitaet(l_Muenzen);     // Kapazitt der Behlter festlegen

/*T Beginn des speziellen Codes fr die IT-Version 0
    Magazin sofort wieder vollstndig geleert.
*/
  while (dasCtMagazin[0]->getInhalt() > 0) dasCtMagazin[0]->entnehmenEins();
  while (dasCtMagazin[1]->getInhalt() > 0) dasCtMagazin[1]->entnehmenEins();
  while (dasCtMagazin[2]->getInhalt() > 0) dasCtMagazin[2]->entnehmenEins();

  l_Muenzen = leseFuellstand();
/*T Ende   des speziellen Codes fr die IT-Version 0  */

  dieGUI2->aktualisiereAnzeige(l_Muenzen);
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void WechselgeldAutomat::ausgebenMuenzen( int betrag)
{
  struct Muenzen l_Auszahlung, l_Muenzen;

  l_Auszahlung = ausgeben(betrag);
  dieGUI1->anzeigenMuenzen(l_Auszahlung);

  l_Muenzen = leseFuellstand();
  dieGUI2->aktualisiereAnzeige(l_Muenzen);

  if (l_Auszahlung.Ct50 * 50 + l_Auszahlung.Ct10 * 10 + l_Auszahlung.Ct5 * 5
                                                                     != betrag)
      dieGUI1->blinkenEin();
  else
      dieGUI1->blinkenAus();
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void WechselgeldAutomat::auffuellenMagazin( )
{
  auffuellen( );
  dieGUI1->blinkenAus();
  dieGUI2->aktualisiereAnzeige( leseFuellstand() );
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
struct Muenzen WechselgeldAutomat::ausgeben( int betrag)
{
int i, l_anz[3];
struct Muenzen l_Muenzen;

  l_Muenzen.Ct50 = 0;
  l_Muenzen.Ct10 = 0;
  l_Muenzen.Ct5 = 0;
  l_anz[0] = dasCtMagazin[0]->getInhalt();
  l_anz[1] = dasCtMagazin[1]->getInhalt();
  l_anz[2] = dasCtMagazin[2]->getInhalt();
  
  while (betrag >= 50 && l_anz[0]>=1) 
	{
	dasCtMagazin[0]->entnehmenEins();
	l_Muenzen.Ct50 ++;
	betrag = betrag -50;
	}
  
  while (betrag >= 10 && l_anz[1]>=1) 
	{
	dasCtMagazin[1]->entnehmenEins();
	l_Muenzen.Ct10 ++;
	betrag = betrag -10;
	}
  
  while (betrag >= 5 && l_anz[2]>=1) 
	{
	dasCtMagazin[2]->entnehmenEins();
	l_Muenzen.Ct5 ++;
	betrag = betrag -5;
	}

  return l_Muenzen;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void WechselgeldAutomat::auffuellen( )
{
  while (dasCtMagazin[0]->hinzufuegenEins());
  while (dasCtMagazin[1]->hinzufuegenEins());
  while (dasCtMagazin[2]->hinzufuegenEins());
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
struct Muenzen WechselgeldAutomat::leseFuellstand()
{
Muenzen l_Muenzen;
  l_Muenzen.Ct50 = dasCtMagazin[0]->getInhalt();
  l_Muenzen.Ct10 = dasCtMagazin[1]->getInhalt();
  l_Muenzen.Ct5 = dasCtMagazin[2]->getInhalt();
  return l_Muenzen;
}
